
ResultsSet GoogleResults = new ResultsSet(); 
ResultsSet WikiResults = new ResultsSet(); 
ArrayList sortedMisspellings; 
PieChart pieChartDrawer = new PieChart();
boolean autoMode = true;
int autoX = -1;
int autoY = -1;
int autoMaxCycles = 3000;
int autoCycle = 0;

String highlightKey = "";

String currentLink = "";

PFont font;

void setup(){
  
  smooth();
  //size(WIDTH, HEIGHT);
  HEIGHT = (int)ceil(N_ROWS*BLOCK_SIZE + MARGIN_Y + BAR_HEIGHT + FONT_MIS_SIZE) + 50 + 150;
  println(HEIGHT);
  size(WIDTH, HEIGHT);
  randomSeed(millis());
  
  // load results
  GoogleResults.loadResultPairs(GoogleFile);
  N_MISSPELLINGS = GoogleResults.getNumberOfMisspellings();
  SUM_POPULARITY = GoogleResults.getSumPopularity();
  println(SUM_POPULARITY);
  sortedMisspellings = GoogleResults.getSortedMisspellings(new RandomComparator());
  GoogleResults.loadLinks(this, sortedMisspellings);


  WikiResults.loadResultPairs(WikiFile);
  
  font = loadFont("GillSans-48.vlw");
  
}

boolean inArea()
{
  int left = 0;
  int right = WIDTH;
  int top = (int)(MARGIN_Y + BAR_HEIGHT + FONT_MIS_SIZE + 50);
  int down = (int)(BLOCK_SIZE*N_COLS + MARGIN_Y + BAR_HEIGHT + FONT_MIS_SIZE + 50);
   return  mouseX > left && mouseX < right && mouseY > top && mouseY < down;
}

int highlightKeyID = -1;
  int value = 0;
  
void keyPressed() {
  
  if (key == ESC)
  {
    key = 0;
    if (highlightKey.length() > 0)
    {
      highlightKey = highlightKey.substring(0,highlightKey.length()-1);
    }
  }
  else if (key != CODED)
  {
    highlightKey = highlightKey + String.valueOf(key);
  }
  println(highlightKey);
}
  
void draw(){
  

  if (inArea())
  {
     autoMode = false; 
     autoCycle = 0;
  }
  else
  {          
        if (autoCycle + autoMaxCycles < millis())
        {
          highlightKeyID = (int)random(0, N_MISSPELLINGS);
          autoCycle = millis();
        }
  }
  
  background(BLOCK_MIN_COLOR);
  
  float x = 0.0; float y = 0.0;
  float ratioG = 0.0; float ratioW = 0.0; float tmp = 0.0;
  for (int r=0; r<N_ROWS; r++)
  {
    for (int c=0; c<N_COLS; c++)
    {
      int keyid = r*N_COLS + c;
      if (keyid == N_MISSPELLINGS) break;
      
      WordPair wordpair =  (WordPair)sortedMisspellings.get(keyid);
      ratioW = WikiResults.getWordPairRatio(wordpair.mis);
      //tmp = (atan(ratioW/wordpair.ratio))*2.0/PI;
      tmp = atan(wordpair.misPop/50000.0)*2.0/PI;
      
      
      x = BLOCK_SIZE*c + MARGIN_X;
      y = BLOCK_SIZE*r + MARGIN_Y + BAR_HEIGHT + FONT_MIS_SIZE + 50;
      
      noStroke();
      if (inBlock(x,y) || (autoMode && highlightKeyID == keyid))
      {
        highlightKeyID = keyid;   
        fill(RED);
        
      }
      else
      {
        if (highlightKey.length() > 0 && wordpair.mis.contains(highlightKey))
        {
          fill(color(blockColor(tmp, 1),0,0));
        }
        else
        {
          fill((float)blockColor(tmp, 1));
        }
      }
      rect(x,y,BLOCK_SIZE,BLOCK_SIZE);
    }
  }
  
  if (highlightKeyID >= 0)
  {
     drawSelected(highlightKeyID);
  }
  
}

void mousePressed() { 
  if (currentLink.length() > 0)
    link(currentLink, "_new"); 
}

void drawSelected(int keyID)
{
   WordPair goog = (WordPair)sortedMisspellings.get(keyID);
   WordPair wiki = WikiResults.getWordPair(goog.mis);
   
   currentLink = "http://www.google.com/search?q=%22" + goog.mis +"%22";
  
   // draw text
   pushMatrix();
   translate(WIDTH/2.0 - 50 - 200, 0.0);
   textFont(font, FONT_MIS_SIZE);
   textAlign(RIGHT);
   fill(WHITE);
   text(goog.mis, 20.0, 20.0, 200, FONT_MIS_SIZE);
   popMatrix();
   
   pushMatrix();
   translate(WIDTH/2.0 + 20, 0.0);
   textFont(font, FONT_MIS_SIZE);
   textAlign(LEFT);
   fill(WHITE);
   text(goog.rep, 0.0, 20.0, 200, FONT_MIS_SIZE);
   popMatrix();
   
   pushMatrix();
   translate(WIDTH/2.0 - 30 - 200, FONT_MIS_SIZE);
   textFont(font, FONT_MIS_SIZE/2.0);
   textAlign(RIGHT);
   fill(COLOR_MIS);
   int kmagnitude = round((float)goog.misPop/1000);
   String misstr = kmagnitude + "K";
   if (kmagnitude < 1) misstr = "< 1K";
   text(misstr, 0.0, 20.0, 200, FONT_MIS_SIZE);
   popMatrix();
   
   pushMatrix();
   translate(WIDTH/2.0 + 20, FONT_MIS_SIZE);
   textFont(font, FONT_MIS_SIZE/2.0);
   textAlign(LEFT);
   fill(COLOR_REP);
   kmagnitude = round((float)goog.repPop/1000);
   misstr = kmagnitude + "K";
   if (kmagnitude < 1) misstr = "< 1K";
   text(misstr, 0.0, 20.0, 200, FONT_MIS_SIZE);
   popMatrix();
   
   // draw bar at bottom
   pushMatrix();
   translate(0, MARGIN_Y + FONT_MIS_SIZE + 50);
   fill(COLOR_MIS);
   rect(0, 0, (float)BAR_WIDTH*goog.ratio, BAR_HEIGHT);
   fill(COLOR_REP);
   rect((float)BAR_WIDTH*goog.ratio, 0, WIDTH-(float)BAR_WIDTH*goog.ratio, BAR_HEIGHT);
   popMatrix();
   
   // draw links
   ArrayList theLinks = GoogleResults.getLinks(goog.mis);
   pushMatrix();
   translate(0, BLOCK_SIZE*N_ROWS + MARGIN_Y + BAR_HEIGHT + FONT_MIS_SIZE + 50 + 10);
   for (int l=0; l<theLinks.size(); l++)
   {
     Link thelink = (Link)theLinks.get(l);
     
     textFont(font, FONT_LINK_SIZE);
     textAlign(LEFT);
     fill(WHITE);
     text(thelink.title, 10.0, (FONT_LINK_SIZE*2)*l + 5, WIDTH-MARGIN_X, FONT_LINK_SIZE);
     textFont(font, FONT_LINK_SIZE*0.75);
     textAlign(LEFT);
     fill(WHITE);
     String desc = thelink.url;
     if (desc == null) desc = "";
     else if (desc.length() > 130) desc = desc.substring(0,130) + "...";
     text(desc, 10.0, (FONT_LINK_SIZE*2)*l + 5 + FONT_LINK_SIZE, WIDTH-MARGIN_X, FONT_LINK_SIZE*0.75);
   }
   popMatrix();
   
   if (highlightKey.length() > 0)
   {
   pushMatrix();
   translate(0.0,HEIGHT - FONT_LINK_SIZE*0.75);
   textFont(font, FONT_LINK_SIZE);
   textAlign(RIGHT);
   fill(REDDARK);
   text("Looking for: " + highlightKey, -10.0,-10.0, WIDTH, FONT_LINK_SIZE);
   popMatrix();
   }
   
}

